// trieda pre pracu s OpenGL kamerou
class COGLcamera {
public:
 COGLcamera();          // konstruktor
 virtual ~COGLcamera(); // destruktor

 // inicializacia kamery a OpenGL kresliacej plochy
 void cam_init(GLfloat w,GLfloat h);
 // aktualizacia nastaveni kamery
 void cam_update(void);
 // posun kamery
 void cam_move(void);
 // rotacia kamery
 void cam_rotate(GLfloat x,GLfloat y,GLfloat z);
 // reset pohladu kamery
 void cam_reset(int init_bit);
 // zap/vyp detekcie kolizii
 void CollisionOnOff(void);
 // detekcia kolizie kamery
 void cam_collision(GLuint T_num,GLuint *T_pointer);

 GLfloat matrix[16];                             // matica kamery
 GLfloat posx,posy,posz,movx,movy,movz;          // poloha, posun
 GLfloat oldx,oldy,oldz;                         // povodna poloha
 GLfloat targetx,targety,targetz;                // smer
 // indikatory pre vykonavanie definovanych posunov kamery
 GLubyte goForward,goBack,goUp,goDown,goRight,goLeft,goFast;
 GLubyte goJump;

 GLubyte isFire;

 GLubyte movetype;                               // typ pohybu

 GLfloat ogl_fps; // pocitadlo FPS (snimky za sekundu)

 GLfloat scr_w,scr_h; // sirka, vyska okna

 GLfloat *cam_triangle_array; // pole trojuholnikov, s ktorymi prebehne
                              // test na koliziu

 // zap/vyp dektekcie kolizii
 GLubyte collision_onoff;
 // cas posobenia gravitacie
 GLfloat gravityTime;
private:
 GLfloat angx,angy,angz,rotx,roty,rotz;          // otocenie, rotacia
 GLfloat speed,slide,alt;                        // rychlost, bocny pohyb, zmena vysky
 GLfloat acceleration,gravity;                   // zrychlenie, gravitacne zrychlenie
 GLfloat viewdist;                               // maximalny dohlad
 GLfloat FOV;                                    // uhol pohladu
 GLfloat JumpPower;

 GLfloat go_x,go_y,go_z;

 GLfloat rotx_factor,roty_factor,rotz_factor;    // konstanty pre upravu rychlosti rotacie
 GLfloat movx_factor,movy_factor,movz_factor;    // konstanty pre upravu rychlosti posunu

 GLuint t_a,t_b; // pomocne premenne

 // ulozenie stareho a noveho casoveho okamihu (ms)
 GLuint oldTime,actTime;
 // cas vykreslenia sceny
 GLfloat difTime;
 // pocitadlo pre FPS (pocet snimkov)
 GLfloat ogl_frames;

 // test, ci je "kamera v trojuholniku" *************************************
 bool CameraInTriangle(GLfloat c1,GLfloat c2, GLfloat c3,
                       GLfloat v1,GLfloat v2, GLfloat v3, GLfloat v4,
                       GLfloat v5,GLfloat v6, GLfloat v7, GLfloat v8,
                       GLfloat v9,GLfloat v10,GLfloat v11,GLfloat v12);
};
