// hlavickove subory *******************************************************
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// GLEXT kniznica
#include <GL/glext.h>

#include <SDL/SDL.h>

// .h subor
#include "OGLext.h"

// konstruktor *************************************************************
OGLext::OGLext()
{
 glActiveTextureARB=NULL;
 glMultiTexCoord2fARB=NULL;

 maxTexelUnits=1; // kazda karta ma aspon 1 texturovaciu jednotku
}

// destruktor **************************************************************
OGLext::~OGLext()
{

}

// inicializacia rozsireni *************************************************
int OGLext::Ext_init()
{
 glGetString(GL_EXTENSIONS);

 glGetIntegerv(GL_MAX_TEXTURE_UNITS_ARB,&maxTexelUnits);

 glActiveTextureARB=(PFNGLACTIVETEXTUREARBPROC) SDL_GL_GetProcAddress("glActiveTextureARB");
 glMultiTexCoord2fARB=(PFNGLMULTITEXCOORD2FARBPROC) SDL_GL_GetProcAddress("glMultiTexCoord2fARB");

 return(0);
}

// multitexturovana kocka **************************************************
void OGLext::MultiTCube(GLuint T1,GLuint T2,GLfloat size)
{
 glPushAttrib(GL_LIGHTING_BIT|GL_TEXTURE_BIT|GL_FOG_BIT);
 glDisable(GL_LIGHTING);
 glDisable(GL_TEXTURE_2D);
 glDisable(GL_FOG);
 glDisable(GL_BLEND);

 // texturovacia jednotka0
 // texture-combiner0=GL_REPLACE
 glActiveTextureARB(GL_TEXTURE0_ARB);
 glEnable(GL_TEXTURE_2D);
 glBindTexture(GL_TEXTURE_2D,T1);
 glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_COMBINE_EXT);
 glTexEnvf(GL_TEXTURE_ENV,GL_COMBINE_RGB_EXT,GL_REPLACE);
 // texturovacia jednotka1
 // texture-combiner1=GL_ADD (multitexture-equivalent to ONE blending)
 glActiveTextureARB(GL_TEXTURE1_ARB);
 glEnable(GL_TEXTURE_2D);
 glBindTexture(GL_TEXTURE_2D,T2);
 glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_COMBINE_EXT);
 glTexEnvf(GL_TEXTURE_ENV,GL_COMBINE_RGB_EXT,GL_ADD);

 glColor4f(1.0f,1.0f,1.0f,1.0f); // farba
 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,1.0f);    // predna stena
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,0.0f);
  glVertex3f(-size,-size,size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,0.0f);
  glVertex3f(size,-size,size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,1.0f);
  glVertex3f(size,size,size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,1.0f);
  glVertex3f(-size,size,size);

  glNormal3f(1.0f,0.0f,0.0f);    // prava stena
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,0.0f);
  glVertex3f(size,-size,size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,1.0f);
  glVertex3f(size,size,-size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,1.0f);
  glVertex3f(size,size,size);
 glEnd();

 glActiveTextureARB(GL_TEXTURE1_ARB);
 glDisable(GL_TEXTURE_2D);
 glActiveTextureARB(GL_TEXTURE0_ARB);

 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,-1.0f);   // zadna stena
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,0.0f);
  glVertex3f(size,-size,-size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,0.0f);
  glVertex3f(-size,-size,-size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,1.0f);
  glVertex3f(-size,size,-size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,1.0f);
  glVertex3f(size,size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);   // lava stena
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,0.0f);
  glVertex3f(-size,-size,-size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,0.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,0.0f);
  glVertex3f(-size,-size,size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,1.0f,1.0f);
  glVertex3f(-size,size,size);
  glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0.0f,1.0f);
  glMultiTexCoord2fARB(GL_TEXTURE1_ARB,0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();

 glBindTexture(GL_TEXTURE_2D,T2);

 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,-1.0f,0.0f);   // dolna stena
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,-size);
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,-size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,-size,size);

  glNormal3f(0.0f,1.0f,0.0f);    // horna stena
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,size,size);
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();

 glPopAttrib();
}
