// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>

// funkcie pre pracu s fontom
#include "lib/glTexFont.h"

// .h subor
#include "OGLtext.h"

// konstruktor *************************************************************
COGLtext::COGLtext()
{
 mystring=mybuf;
 TextColor[0]=1.0f; TextColor[1]=1.0f; TextColor[2]=1.0f; TextColor[3]=1.0f;
}

// destruktor **************************************************************
COGLtext::~COGLtext()
{

}

// inicializacia vypisovania OpenGL textu **********************************
int COGLtext::text_initialize(void)
{
 // nahratie fontu
 if (!fontLoad("data/font.tga")) {
  fprintf(stderr,"Chyba nahratia OpenGL fontu!\n");
  return(1);
 }

 return(0);
}

// zacatie vypisu textu ****************************************************
void COGLtext::OpenDrawString(void)
{
 glPushAttrib(GL_LIGHTING_BIT|GL_DEPTH_BUFFER_BIT|GL_TEXTURE_BIT);
 glDisable(GL_LIGHTING);
 glDisable(GL_DEPTH_TEST);
 glDisable(GL_TEXTURE_2D);

 glMatrixMode(GL_PROJECTION);
 glPushMatrix();
 glLoadIdentity();
 glMatrixMode(GL_MODELVIEW);
 glPushMatrix();
 glLoadIdentity();
}

// vypis textu *************************************************************
void COGLtext::DrawString(GLfloat x,GLfloat y)
{
 fontColor(TextColor[0],TextColor[1],TextColor[2]);
 fontSize(FontSize);
 fontDrawString((int) x,(int) y,mystring);

 /*
 fontSize(10);
 fontShadow();
 fontShadowColor(0.5,0.5,0.5);
 fontColor(1,0,0);
 fontDrawString(0,500,"OpenGL Extensions:");
 fontRegion(10,500,10*50,10*10);
 fontDrawString(-1,-1,glExten);

 fontGradient();
 fontGradientColor(1,1,1);
 */
}

// ukoncenie vypisu textu **************************************************
void COGLtext::CloseDrawString(void)
{
 glPopMatrix();
 glMatrixMode(GL_PROJECTION);
 glPopMatrix();
 glMatrixMode(GL_MODELVIEW);

 glPopAttrib();

 glColor4f(1.0f,1.0f,1.0f,1.0f); // aktualna farba bude biela
}

void COGLtext::SetTextColor(GLfloat a,GLfloat b,GLfloat c)
{
 TextColor[0]=a; TextColor[1]=b; TextColor[2]=c;
}

void COGLtext::SetFontSize(GLuint a)
{
 FontSize=a;
}

