// hlavickove subory *******************************************************
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "OGLtexture.h"

// konstruktor *************************************************************
COGLtexture::COGLtexture()
{
 texture_id[0]=0;
}

// destruktor **************************************************************
COGLtexture::~COGLtexture()
{

}

// nahratie textury ********************************************************
int COGLtexture::LoadTexture(GLuint id,char *myfile)
{
 // alokovanie miesta pre data textury
 SDL_Surface *TextureImage;

 TextureImage=SDL_LoadBMP(myfile);

 // nahratie suboru s bitmapou
 if (TextureImage!=NULL) {
  glGenTextures(1,&texture_id[id]);
  // pripojenie textury
  glBindTexture(GL_TEXTURE_2D,texture_id[id]);
  // nastavenie LINEAR filteringu
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  // vygenerovanie textury
  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage->w,TextureImage->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage->pixels);
 }
 else return(1);

 // uvolnenie pouzitej pamate
 if (TextureImage) SDL_FreeSurface(TextureImage);

 return(0);
}

// nahratie textury zameriavacieho kriza ***********************************
int COGLtexture::LoadCrosshairTexture(char *myfile)
{
 // alokovanie miesta pre data textury
 SDL_Surface *TextureImage[1];

 // nahratie suboru s bitmapou
 if ((TextureImage[0]=SDL_LoadBMP(myfile))) {
  glGenTextures(1,&crosshair_tex_id);
  // pripojenie textury
  glBindTexture(GL_TEXTURE_2D,crosshair_tex_id);
  // nastavenie LINEAR filteringu
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  // vygenerovanie textury
  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[0]->w,TextureImage[0]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[0]->pixels);
 }
 else return(1);

 // uvolnenie pouzitej pamate
 if (TextureImage[0]) SDL_FreeSurface(TextureImage[0]);

 return(0);
}

// vykreslenie zameriavacieho kriza ****************************************
int COGLtexture::DrawCrosshair(GLfloat w,GLfloat h)
{
 glPushAttrib(GL_DEPTH_BUFFER_BIT|GL_TEXTURE_BIT);
 glDisable(GL_DEPTH_TEST);
 glEnable(GL_TEXTURE_2D);

 glBlendFunc(GL_ONE,GL_ONE);
 glEnable(GL_BLEND);

 glMatrixMode(GL_PROJECTION);
 glPushMatrix();
 glLoadIdentity();
 glOrtho(0.0f,w,0.0f,h,-1.0f,1.0f);
 glMatrixMode(GL_MODELVIEW);
 glPushMatrix();
 glLoadIdentity();

 glTranslated(w/2.0f,h/2.0f,0.0f);

 glBindTexture(GL_TEXTURE_2D,crosshair_tex_id);

 glBegin(GL_QUADS);
  glTexCoord2f(0.0f,0.0f); glVertex3f(-32.0f,-32.0f,0.0f);
  glTexCoord2f(1.0f,0.0f); glVertex3f(32.0f,-32.0f,0.0f);
  glTexCoord2f(1.0f,1.0f); glVertex3f(32.0f,32.0f,0.0f);
  glTexCoord2f(0.0f,1.0f); glVertex3f(-32.0f,32.0f,0.0f);
 glEnd();

 glDisable(GL_BLEND);

 glPopMatrix();
 glMatrixMode(GL_PROJECTION);
 glPopMatrix();
 glMatrixMode(GL_MODELVIEW);

 glPopAttrib();

 return(0);
}
